//+------------------------------------------------------------------+
//|                                                  test_OpenMP.mq5 |
//|                               Copyright 2019, Vladimir Mikhailov |
//|                                                mikh.vl@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Vladimir Mikhailov"
#property link      "mikh.vl@gmail.com"
#property version   "1.00"
#property script_show_inputs
#property description "Test OpenMP."

#import "ompmql.dll"
void test_openmp(const double &x[], const double &y[], double &z[], const int row, const int col);
#import
//--- input
input int Row = 1000000;
input int Col = 400;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   double x[], y[], z[];
   srand(GetTickCount());
   
//--- set x array
   ArrayResize(x, Row * Col);
   for(int i = 0; i < Row * Col; i++)
     {
      x[i] = double(rand()) / 32767.0;
     }

//--- set y array
   ArrayResize(y, Col);
   for(int i = 0; i < Col; i++)
     {
      y[i] = double(rand()) / 32767.0;
     }
   
//--- set z array
   ArrayResize(z, Row);

//--- test Mql 
   ArrayInitialize(z, 0.0);
   ulong start=GetMicrosecondCount();
   
   for(int i = 0; i < Row; i++)
     {
      int k = i * Col;
      for(int j = 0; j < Col; j++)
        {
         z[i] += x[k + j] * y[j];
        }
     }
   
   ulong stop=GetMicrosecondCount();
   
   Print("MQL. z[0]=", z[0], " z[1]=", z[1], " z[2]=", z[2], "... Time: ", (stop - start) / 1000.0, " msec");
      
//--- Test OpenMP
   for(int i=0;i<5;i++)
     {
      ArrayInitialize(z, 0.0);
      start=GetMicrosecondCount();
   
      test_openmp(x, y, z, Row, Col);
   
      stop=GetMicrosecondCount();
   
      Print("OpenMP. z[0]=", z[0], " z[1]=", z[1], " z[2]=", z[2], "... Time: ", (stop - start) / 1000.0, " msec");
     
      //DebugBreak();
     }
  }
//+------------------------------------------------------------------+
